{% extends "base_device.yaml.jinja2" %}

{% block device_setup %}

{%- set os_url = "https://gitlab.com/Linaro/trustedsubstrate/ts-testing/-/jobs/artifacts/main/raw/image/efiboot.wic.xz?job=build" %}
{%- set os_filename = os_url.split('/')[-1].split('?')[0] %}
{%- set os, os_extension = splitext(os_filename) %}

device_type: rk3399-rock-pi-4b

job_name: {{ lava_job_name }}

visibility: public
timeouts:
  job: { minutes: 60 }
  action: { minutes: 60 }
  connection: { minutes: 2 }

context:
  lava_test_results_dir: /var/lib/lava-%s

actions:

- deploy:
    to: downloads
    failure_retry: 3
    timeout: { minutes: 20 }
    images:
      firmware:
        url: {{ firmware_url }}
        {%- set firmware_path, firmware_extension = splitext(firmware_url) %}
        compression: {{ firmware_extension[1:] }}
      os:
        url: {{ os_url }}
        compression: {{ os_extension[1:] }}
      script:
        url: https://gitlab.com/Linaro/blueprints/ci/-/raw/HEAD/support_files/ts-merge-images.sh
      capsule:
        url: {{ capsule_url }}
      invalid_sig:
        url: {{ invalid_capsule_url }}
      {%- if testexport_url %}
      testexport:
        url: {{ testexport_url }}
      {%- endif %}
    postprocess:
      docker:
        image: debian
        steps:
          {%- set firmware_basename = basename(firmware_path) %}
          - 'apt-get update'
          - 'apt-get install -qy fdisk gdisk mtools'
          - mcopy -o -i efiboot.wic@@1048576 rockpi4b_fw.capsule ::/EFI/BOOT/valid.capsule
          - mcopy -o -i efiboot.wic@@1048576 rockpi4b_fw_invalid_sig.capsule ::/EFI/BOOT/invalid.capsule
          - mcopy -i efiboot.wic@@1048576 ::/EFI/BOOT/startup.nsh .
          - sed -i 's#ledge.efi -f.*#ledge.efi -f -u validation-linaro-org.s3.eu-west-1.amazonaws.com/testdata/ledge/yocto-arm64-lava.iso#g' startup.nsh
          - cat startup.nsh
          - mcopy -o -i efiboot.wic@@1048576 startup.nsh ::/EFI/BOOT/
          - 'fdisk -l {{ firmware_basename }}'
          - 'fdisk -l {{ os }}'
          - 'bash ts-merge-images.sh {{ firmware_basename }} {{ os }}'
          - 'fdisk -l {{ firmware_basename }}'

- deploy:
    to: flasher
    failure_retry: 3
    timeout: { minutes: 10 }
    images:
      image:
        url: downloads://{{ firmware_basename }}

- boot:
    timeout:
      minutes: 15
    method: minimal
    prompts:
      - root@(.*):[/~]#
    auto_login:
      login_prompt: "login:"
      username: "root"
    transfer_overlay:
      download_command: wget -t 20 --waitretry 20 --retry-connrefused --retry-on-host-error --retry-on-http-error=401,403
      unpack_command: tar -C /var/lib/ -xzvf

{% endblock %}
